#include <amxmodx>
#include <amxmisc>
new const sound_first_sound[] = "radio/shut_up_fucker.wav"
new Ips[MAX_PLAYERS][39],SteamIds[MAX_PLAYERS][32]
new max_ip=0,max_steam=0
new radio_msg[][] = {
	"coverme", "takepoint", "holdpos", "regroup", "followme", "takingfire", 
	"go", "fallback", "sticktog", "getinpos", "stormfront", "report", 
	"roger", "enemyspot", "needbackup", "sectorclear", "inposition", "reportingin", "getout", "negative", "enemydown"
}

new radio_menu[][] = {"radio1", "radio2", "radio3", "radio4"}

public plugin_precache()
{
    precache_sound(sound_first_sound)
}

public plugin_init()
{
	register_plugin("Radio Gag", "1.0", "CT Spawn")

	for(new i = 0; i < sizeof(radio_msg); i++)
	{
		register_clcmd(radio_msg[i], "ClCmd_Radio")
	}

	for(new i = 0; i < sizeof(radio_menu); i++)
	{
		register_clcmd(radio_menu[i],"ClCmd_RadioMenu")
	}
	register_concmd( "amx_rgag","CmdGagPlayer",ADMIN_KICK, "amx_rgag <nick | authid | #userid> (for gag radio spammer)" )
	register_concmd( "amx_ip_rgag","CmdGagPlayerIp",ADMIN_KICK, "amx_ip_rgag <ip> (for gag radio spammer) ^"show ip by 'amx_who' ^"" )
	register_concmd( "amx_unrgag","CmdUnGagPlayer",ADMIN_KICK, "amx_unrgag <nick | authid | #userid> (for ungag radio spammer)" )
	register_concmd( "amx_ip_unrgag","CmdUnGagIpPlayer",ADMIN_KICK, "amx_ip_unrgag <ip> (for ungag radio spammer) ^"show ip by 'amx_who' ^"" )
}

public ClCmd_Radio(id)
{
	if(_gag(id))
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE
}

public ClCmd_RadioMenu(id)
{
	if(_gag(id))
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE
}

public CmdUnGagPlayer( const id, const iLevel, const iCid ){

	if( !cmd_access( id, iLevel, iCid, 1 ) )
	{
		return PLUGIN_HANDLED;
	}
	new arg[32], name[32],Nameo[32],arg_tst[32]
	read_argv(1, arg, charsmax(arg))
	trim(arg)
	copy(arg_tst,charsmax(arg_tst),arg)
	strtolower(arg_tst)
	if(contain(arg_tst,"steam_")!=-1){
		copy(Nameo,charsmax(Nameo),arg)
	}
	else{
		new iPlayer = cmd_target1( id, arg );
		
		if( !iPlayer )
		{
			return PLUGIN_HANDLED;
		}
		else{
			get_user_authid(iPlayer,arg,charsmax(arg))
			get_user_name(iPlayer,Nameo,charsmax(Nameo))
		}
	}
	if(ungag_steam(arg)){
		get_user_name(id, name, charsmax(name))
		client_print_color(0,print_team_blue,"^1[^4Radio Gag System^1] ^4%s^1 has ^3ungag^1 player : ^4%s^1  ",name,Nameo)
	}
	return PLUGIN_HANDLED;
}

public CmdGagPlayer( const id, const iLevel, const iCid )
{
	if( !cmd_access( id, iLevel, iCid, 1 ) )
	{
		return PLUGIN_HANDLED;
	}
	new arg[32], name[32],Nameo[32],arg_tst[32]
	read_argv(1, arg, charsmax(arg))
	trim(arg)
	copy(arg_tst,charsmax(arg_tst),arg)
	strtolower(arg_tst)
	if (contain(arg_tst,"steam_")!=-1){
		copy(Nameo,charsmax(Nameo),arg)
	}
	else{
		new iPlayer = cmd_target1( id, arg );
		
		if( !iPlayer )
		{
			return PLUGIN_HANDLED;
		}
		else{
			get_user_authid(iPlayer,arg,charsmax(arg))
			get_user_name(iPlayer,Nameo,charsmax(Nameo))
		}
	}
	if (equali(arg, "STEAM_ID_PENDING") ||
		equali(arg, "STEAM_ID_LAN") ||
		equali(arg, "HLTV") ||
		equali(arg, "4294967295") ||
		equali(arg, "VALVE_ID_LAN") ||
		equali(arg, "VALVE_ID_PENDING"))
	{
		// Hopefully we never get here, so ML shouldn't be needed
		console_print(id, "Cannot gag %s try with ^"amx_ip_rgag donkey_ip^"", arg);
		return PLUGIN_HANDLED;
	}

	new len=arraylength0(SteamIds)
	
	for(new i=0; i<len;i++){
		if(equali(SteamIds[i][0],arg)){
			return PLUGIN_HANDLED
		}
	}
	SteamIds[len]=arg
	max_steam=len+1
	get_user_name(id, name, charsmax(name))
	client_print_color(0,print_team_red,"^1[^4Radio Gag System^1] ^4%s^1 has ^3gag^1 player : ^4%s^1  ",name,Nameo)

	return PLUGIN_HANDLED
}

public CmdUnGagIpPlayer( const id, const iLevel, const iCid ){

	if( !cmd_access( id, iLevel, iCid, 1 ) )
	{
		return PLUGIN_HANDLED;
	}
	new arg[39], name[32]
	read_argv(1, arg, charsmax(arg))
	trim(arg)

	if(ungag_ip(arg)){
		get_user_name(id, name, charsmax(name))
		client_print_color(0,print_team_blue,"^1[^4Radio Gag System^1] ^4%s^1 has ^3ungag^1 player : ^4%s^1  ",name,arg)
	}
	return PLUGIN_HANDLED;
}

public CmdGagPlayerIp( const id, const iLevel, const iCid )
{
	if( !cmd_access( id, iLevel, iCid, 1 ) )
	{
		return PLUGIN_HANDLED;
	}
	new arg[39], name[32]
	read_argv(1, arg, charsmax(arg))
	trim(arg)

	// Limited access to this command
	if (equali(arg, "loopback") ||
		equali(arg, "localhost") ||
		equali(arg, "127.0.0.1") ||
		equali(arg, "::1"))
	{
		console_print(id, "Cannot gag %s , this is the server ip !", arg)
		return PLUGIN_HANDLED
	}
	if(!ip_valid(arg)){
		console_print(id, "Cannot gag %s , this is not valid ip !", arg)
		return PLUGIN_HANDLED
	}
	new len=arraylength0(Ips)		
	for(new i=0; i<len;i++){
		if(equali(Ips[i][0],arg)){
			return PLUGIN_HANDLED
		}
	}
	Ips[len]=arg
	max_ip=len+1
	get_user_name(id, name, charsmax(name))
	client_print_color(0,print_team_red,"^1[^4Radio Gag System^1] ^4%s^1 has ^3gag^1 player : ^4%s^1  ",name,arg)

	return PLUGIN_HANDLED	
}

public _gag(id){
	if( is_user_alive( id ) ){
		if(get_donkey_info(id)){
			user_slap(id, 10)
			client_cmd(id,"spk sound/radio/shut_up_fucker.wav")
			client_print_color(id,print_team_red,"^1[^4Radio Gag System^1] ^4shut^1 your ^3mouth^1 and ^4shut^1 your ^3a**^1 slap hp ^4: ^1-10")
			return true
		}
	}
	return false
}

public get_donkey_info(id){
	new steamid[32],ip[39]
	if (max_ip>0){
		if(is_user_connected(id)){
			get_user_ip(id,ip,charsmax(ip),1)
			for(new i;i<max_ip;i++){
				if(equali(Ips[i][0],ip)){
					return true
				}
			}
		}
	}
	if (max_steam>0){
		if(is_user_connected(id)){
			get_user_authid(id,steamid,charsmax(steamid))
			for(new i;i<max_steam;i++){
				if(equali(SteamIds[i][0],steamid)){
					return true
				}
			}
		}
	}
	return false
}

public arraylength0(array[][]){
	new count=0
	for(new i=0;i<MAX_PLAYERS;i++){
		if(array[i][0]!=0){
			count++
		}
	}
	return count
}

public ip_valid(source[]){
	new players[MAX_PLAYERS],num,ip[39]
	get_players(players,num)
	new i;
	for(i=0;i<num;i++){
		get_user_ip(players[i],ip,charsmax(ip),1)
		if (equali(ip[0],source)){
			return true
		}
	}
	return false
}

public ungag_steam(source[]){
	new SteamIds_test[MAX_PLAYERS][32],count=0,bool:s=false
	for (new i=0; i<MAX_PLAYERS;i++){
		if((SteamIds[i][0]!=0)&&(!equali(SteamIds[i][0],source))){
			copy(SteamIds_test[count],32,SteamIds[i])
			count++
			SteamIds[i][0]=0
		}
		else if (equali(SteamIds[i][0],source)){
			SteamIds[i][0]=0
			s=true
		}
	}
	for (new i=0; i<count;i++){
		copy(SteamIds[i],32,SteamIds_test[i])
	}
	max_steam=count
	return s
}

public ungag_ip(source[]){
	new Ips_test[MAX_PLAYERS][39],count=0,bool:s=false
	for (new i=0; i<MAX_PLAYERS;i++){
		if((Ips[i][0]!=0)&&(!equali(Ips[i][0],source))){
			copy(Ips_test[count],39,Ips[i])
			count++
			Ips[i][0]=0
		}
		else if (equali(Ips[i][0],source)){
			Ips[i][0]=0
			s=true
		}
	}
	for (new i=0; i<count;i++){
		copy(Ips[i],39,Ips_test[i])
	}
	max_ip=count
	return s
}

public cmd_target1(id, const arg[])
{
	new player = find_player("bl", arg);
	if (player)
	{
		if (player != find_player("blj", arg))
		{
			console_print(id, "%L", id, "MORE_CL_MATCHT");
			return 0;
		}
	}
	else if ((player = find_player("c", arg)) == 0 && arg[0] == '#' && arg[1])
	{
		player = find_player("k", str_to_num(arg[1]));
	}
	if (!player)
	{
		console_print(id, "%L", id, "CL_NOT_FOUND");
		return 0;
	}
	return player;
}
